
/** @class_declaration envioMailJasper */
/////////////////////////////////////////////////////////////////
//// ENVIO MAIL JASPER //////////////////////////////////////////
class envioMailJasper extends pubEnvioMail /** %from: envioMail */  {
	var ficheroCreado:Boolean = false;
	var fichero:String;
	var comando:Array;
	var ciclosLlamada:Number = 0;
	function envioMailJasper( context ) { pubEnvioMail ( context ); }
	function enviarCorreo(cuerpo:String, asunto:String, arrayDest:Array, arrayAttach:Array) {
		return this.ctx.envioMailJasper_enviarCorreo(cuerpo, asunto, arrayDest, arrayAttach);
	}
	function componerCorreo(cuerpo:String, asunto:String, arrayDest:Array, arrayAttach:Array):String {
		return this.ctx.envioMailJasper_componerCorreo(cuerpo, asunto, arrayDest, arrayAttach);
	}
	function comprobarFichero() {
			this.ctx.envioMailJasper_comprobarFichero();
	}
}
//// ENVIO MAIL JASPER //////////////////////////////////////////
/////////////////////////////////////////////////////////////////

/** @class_definition envioMailJasper */
/////////////////////////////////////////////////////////////////
//// ENVIO MAIL JASPER //////////////////////////////////////////
function envioMailJasper_enviarCorreo(cuerpo:String, asunto:String, arrayDest:Array, arrayAttach:Array):Boolean
{
	var util:FLUtil = new FLUtil;
	var documentoCreado:Boolean = false;
	var intentos:Number = 0;
	this.iface.ficheroCreado = false;
	this.iface.fichero = false;
	this.iface.comando = this.iface.componerCorreo(cuerpo, asunto, arrayDest, arrayAttach);
	var retorno:Boolean;
	if (!this.iface.comando) {
		return false;
	}
	if (arrayAttach && arrayAttach[0])
		{
		this.iface.fichero = arrayAttach[0];

		if (File.exists(this.iface.fichero))
			File.remove(this.iface.fichero);

		this.iface.comprobarFichero();

		}
	else
		{

	var res:Array = this.iface.ejecutarComandoAsincrono(flfactppal.iface.comando);
		}
	return true;
}

function envioMailJasper_componerCorreo(cuerpo:String, asunto:String, arrayDest:String, arrayAttach:String):Array
{
	var util:FLUtil = new FLUtil();
	var clienteCorreo = util.readSettingEntry("scripts/flfactinfo/clientecorreo");
	var tipoEnvio:String;
	if (!clienteCorreo || clienteCorreo == "") {
		MessageBox.warning(util.translate("scripts", "No tiene establecido el tipo de cliente de correo.\nDebe establecer este valor en la pestaa Correo del formulario de empresa"), MessageBox.Ok, MessageBox.NoButton);
		return false;
	}
	var nombreCorreo = util.readSettingEntry("scripts/flfactinfo/nombrecorreo");
	if (!nombreCorreo || nombreCorreo == "") {
		MessageBox.warning(util.translate("scripts", "No tiene establecido el nombre del ejecutable del programa de correo.\nDebe establecer este valor en la pestaa Correo del formulario de empresa"), MessageBox.Ok, MessageBox.NoButton);
		return false;
	}

	var destinatarios:String = "";
	for (var i:Number = 0; i < arrayDest.length; i++) {
		if (i > 0) {
			destinatarios += "\,";
		}
		destinatarios += arrayDest[i]["direccion"];
	}
	var documentos:String = "";
	if (arrayAttach) {
		documentos = arrayAttach.join(" ");
	}

	if (!arrayDest[0]["tipo"] || arrayDest[0]["tipo"] =="")
		tipoEnvio = "to";

	if (!tipoEnvio)
		tipoEnvio = arrayDest[0]["tipo"];

 	var comando:Array;
	switch (clienteCorreo) {
		case "Thunderbird": {
			if (documentos != "") {
				comando = [nombreCorreo, "-compose", tipoEnvio + "='" + destinatarios + "',subject=", asunto, ",body=", cuerpo, ",attachment=file://" + documentos];
			} else {
				comando = [nombreCorreo, "-compose", tipoEnvio + "='" + destinatarios + "',subject=", asunto, ",body=", cuerpo];
			}
			break;
		}
		case "Thunderbird 3+": {
			if (documentos != "") {
				comando = [nombreCorreo + " -compose to='" + destinatarios + "',subject='" + asunto + "',body='" + cuerpo + "',attachment=file://" + documentos];
			} else {
				comando = [nombreCorreo + " -compose " + tipoEnvio + "='" + destinatarios + "',subject='" + asunto + "',body='" + cuerpo + "'"];
				}
			break;

			}

		case "Outlook": {
			if (documentos != "") {
 				documentos = Dir.convertSeparators(documentos);
				comando = ["\"" + nombreCorreo + "\" /c", "ipm.note", "/m", destinatarios, "/a", documentos];
			} else {
				comando = ["\"" + nombreCorreo + "\" /c", "ipm.note", "/m" , destinatarios];
			}
			break;
		}
		case "KMail": {
			if (documentos != "") {
				comando = [nombreCorreo , destinatarios, "-s", asunto, "--body", cuerpo, documentos];
			} else {
				comando = [nombreCorreo , destinatarios, "-s", asunto, "--body", cuerpo];
			}
			break;
		}
		default: {

		}
	}
	return comando;
}

function envioMailJasper_comprobarFichero()
{
//	debug("Llamada ...");
	var util:FLUtil = new FLUtil();
	if (!File.exists(this.iface.fichero) && flfactppal.iface.ciclosLlamada <= 30)
			{
			sys.AQTimer.singleShot(1000, flfactppal.iface.comprobarFichero);
			flfactppal.iface.ciclosLlamada++;
			}
	else
	{
	if (flfactppal.iface.ciclosLlamada > 30)
		{
		MessageBox.warning(util.translate("scripts", "Hubo un error al generar el fichero adjunto.\nOperacin cancelada."), MessageBox.Ok, MessageBox.NoButton);
		flfactppal.iface.ciclosLlamada = 0;
		return;
		}
	var res:Array = this.iface.ejecutarComandoAsincrono(flfactppal.iface.comando);
//	debug("terminado");
	}
}
//// ENVIO MAIL JASPER //////////////////////////////////////////
/////////////////////////////////////////////////////////////////

